﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;

namespace AddNewComboItem108907
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.Load += new EventHandler(Form1_Load);
            this.ultraComboEditor1.Editor.KeyDown += new KeyEventHandler(Editor_KeyDown);
            this.ultraComboEditor1.SelectionChanged += new EventHandler(ultraComboEditor1_SelectionChanged);
        }

        //Create a reference variable to monitor whether an item has been selected within the UltraComboEditor's
        //dropdown
        bool itemSelected = false;

        //Declare a ValueListItem that will be used to reference the selectedItem
        Infragistics.Win.ValueListItem selectedItem;

        //Declare a ValueListItem that will be used to add a new item within the Items collection
        Infragistics.Win.ValueListItem newItem;

        void ultraComboEditor1_SelectionChanged(object sender, EventArgs e)
        {
            //Monitor whether an item within the dropdown has been selected
            itemSelected = true;

            //Allocate a referecne to the selected item's ValueListItem within the ultraComboEditor's Items collection
            selectedItem = ultraComboEditor1.SelectedItem;
        }

        void Editor_KeyDown(object sender, KeyEventArgs e)
        {
            //If the enter key has been pressed, but an item was not previously selected, prepare to create a new item
            if (e.KeyCode == Keys.Enter && itemSelected == false)
            {
                //Optional, force the editor out of edit mode
                ultraComboEditor1.Editor.ExitEditMode(true, true);

                //If the item is not already present in the list..
                if (ultraComboEditor1.IsItemInList(ultraComboEditor1.Text) == false)
                {
                    //Add a new item, representing the new value
                    newItem = new Infragistics.Win.ValueListItem(ultraComboEditor1.Text);
                    ultraComboEditor1.Items.Add(newItem);
                }
            }

            //If the enter key is pressed and an item was previously selected, prepare to edit that item
            else if (e.KeyCode == Keys.Enter && itemSelected == true)
            {
                //Optional, force the editor out of edit mode
                ultraComboEditor1.Editor.ExitEditMode(true, true);

                //If the item is not already present in the list, (essentially checking if the supplied value for
                //an item differs from its current value)
                if (ultraComboEditor1.IsItemInList(ultraComboEditor1.Text) == false)
                {

                    //Set the selected item's text to the text entered by the user
                    selectedItem.DataValue = ultraComboEditor1.Text;

                    //Reset our reference variable for the selected item
                    itemSelected = false;
                }
            }
        }

        void Form1_Load(object sender, EventArgs e)
        {
            //Populate the UltraComboEditor's dropdown with some sample items..
            Infragistics.Win.ValueListItem valueListItem1 = new Infragistics.Win.ValueListItem();
            Infragistics.Win.ValueListItem valueListItem2 = new Infragistics.Win.ValueListItem();
            Infragistics.Win.ValueListItem valueListItem3 = new Infragistics.Win.ValueListItem();

            valueListItem1.DataValue = "ValueListItem0";
            valueListItem2.DataValue = "ValueListItem1";
            valueListItem3.DataValue = "ValueListItem2";

            this.ultraComboEditor1.Items.AddRange(new Infragistics.Win.ValueListItem[] {
            valueListItem1,
            valueListItem2,
            valueListItem3});
        }
    }
}
